function evolutionTabController(ScreenService, templateManager, metaDataFactory, ZHPromise, General){
    
    /**
     * Tranforma o JSON da tab em uma widget de fato.
     * 
     * @param {object} widget widget que irá receber a tab.
     * 
     * @param {string} nrparcnegocio nome do campo com o número
     * do parceiro de negócio.
     * 
     * @return widget evolucao construida.
     * 
    */
    function _factoryEvolutionTab(activeWidget) {
        
        
        var evolutionTabWidgetJson = {
            "id": "1722319758311315390513",
            "container":activeWidget.container,
            "parent":activeWidget,
            "name": "WDGT_EVOLUCAO",
            "label": "Evoluções",
            "isVisible": true,
            "showDescriptionOrder": false,
            "template": "widget/master_detail/grid.html",
            "dataSource": {
                "name": "/evolcont_contato",
                "rest": true,
                "lazyLoad": true
            },
            "fieldGroups": [
                {
                    "name": "FG_AGENDAR_TAREFA",
                    "label": "Próxima Tarefa",
                    "collapsible": true,
                    "opened": true
                }
            ],
            "dataSourceFilter": [
                {
                    "name": "NRSEQCONTATO",
                    "operator": "=",
                    "value": ""
                },
                {
                    "name": "NRORG",
                    "operator": "=",
                    "value": "@templateManager.LOGGEDOPERATOR.NRORG@"
                },
                {
                    "name": "CRM_NRORGTRAB",
                    "operator": "=",
                    "value": "@getLocalVar('CRM_NRORGTRABALHO')@"
                }
            ],
            "fields": [
                {
                    "id": "02",
                    "name": "NRSEQCONTATO",
                    "label": "Contato",
                    "template": "field/datetime.html",
                    "showOnForm": false,
                    "showOnList": false,
                    "isVisible": false,
                    "readOnly": false,
                    "class": "6",
                    "defaultValue":"@General.getFieldValue('NRSEQCONTATO', '"+activeWidget.name+"')@",
                    "events": []
                },
                {
                    "id": "03",
                    "name": "NRORG",
                    "label": "Org",
                    "template": "field/datetime.html",
                    "showOnForm": false,
                    "showOnList": false,
                    "isVisible": false,
                    "readOnly": false,
                    "class": "6",
                    "defaultValue":"@getLocalVar('CRM_NRORGTRAB')@",
                    "events": []
                },
                {
                    "id": "04",
                    "name": "DTHREVOLCONT",
                    "label": "Data da Evolução",
                    "template": "field/datetime.html",
                    "showOnForm": true,
                    "showOnList": true,
                    "isVisible": true,
                    "readOnly": false,
                    "defaultValue":"@CRM_Utilities.getDataHoraAtual()@",
                    "class": "6",
                    "events": []
                },
                {
                    "id": "05",
                    "name": "IDSENEVOCONT",
                    "label": "Sentido",
                    "template": "field/select-native.html",
                    "showOnForm": true,
                    "showOnList": true,
                    "class": "6",
                    "valueField": "IDSENEVOCONT",
                    "descriptionField": "NMSENEVOLCONT",
                    "defaultValue": "S",
                    "isVisible": true,
                    "events": [],
                    "validations":{
                        "required":true
                    },
                    "filterProperties":{
                        "validations":{}
                    },
                    "hideEmptyValue":true,
                    "dataSource": {
                        "data": [
                            {
                                "NMSENEVOLCONT": "Entrada",
                                "IDSENEVOCONT":"E"
                            },
                            {
                                "NMSENEVOLCONT": "Saída",
                                "IDSENEVOCONT":"S"
                            }
                        ]
                    }
                },
                {
                    "id": "06",
                    "name": "NMOPERADOR",
                    "label": "Operador Responsável",
                    "template": "field/select.html",
                    "class": "12",
                    "isVisible": true,
                    "showOnList": true,
                    "showOnView": true,
                    "showOnForm": true,
                    "readOnly": false,
                    "dataSource": {
                        "name": "product#/operador",
                        "rest": true,
                        "lazyLoad": true
                    },
                    "defaultValue": "@getLocalVar('CRM_NMOPERADOR')@",
                    "itemsPerPage": 50,
                    "dataSourceFilter": [
                        {
                            "name": "NRORG",
                            "operator": "=",
                            "value": "@getLocalVar('CRM_NRORGTRAB')@"
                        },
                        {
                            "name": "IDATIVO",
                            "operator": "=",
                            "value": "S"
                        }
                    ],
                    "descriptionField": "NMOPERADOR",
                    "valueField": "CDOPEREVOL",
                    "outData":{
                        "CDOPERADOR" : "CDOPEREVOL",
                        "NMOPERADOR" : "NMOPERADOR",
                        "DSEMAILOPER": "DSEMAILOPER"
                    },
                    "showSelectAs": "grid",
                    "fields": [
                        {
                            
                            "name": "NMOPERADOR",
                            "label": "Operador",
                            "showOnList": true
                        }
                    ],
                    "validations": {},
                    "events": []
                },
                {
                    "id": "07",
                    "name": "CDOPEREVOL",
                    "label": "Código Operador",
                    "template": "field/datetime.html",
                    "showOnForm": false,
                    "showOnList": false,
                    "isVisible": false,
                    "readOnly": false,
                    "class": "6",
                    "defaultValue":"@templateManager.LOGGEDOPERATOR.CDOPERADOR@",
                    "events": []
                },
                {
                    "id": "08",
                    "name": "NMTIPOCONT",
                    "label": "Tipo de Contato",
                    "template": "field/select.html",
                    "showSelectAs": "grid",
                    "isVisible": true,
                    "showOnForm": true,
                    "showOnList": true,
                    "class": "6",
                    "readOnly": false,
                    "dataSource": {
                        "name": "product#/crud/tipocont",
                        "rest": true,
                        "lazyLoad": true
                    },
                    "itemsPerPage": 50,
                    "dataSourceFilter": [
                        {
                            "name": "NRORG",
                            "operator": "=",
                            "value": "@getLocalVar('CRM_NRORGTRAB')@"
                        },
                        {
                            "name": "IDATIVO",
                            "operator": "=",
                            "value": "S"
                        }
                    ],
                    "descriptionField": "NMTIPOCONT",
                    "valueField": "CDTIPOCONT",
                    "fields": [
                        {
                            
                            "name": "NMTIPOCONT",
                            "label": "Tipo de Contato",
                            "showOnList": true
                        }
                    ],
                    "validations":{  
                        "required":true
                    },
                    "events": []
                },
                {
                    "id": "09",
                    "name": "NMMOTIEVOCON",
                    "label": "Motivo da Evolução",
                    "template": "field/select.html",
                    "class": "6",
                    "isVisible": true,
                    "showOnList": true,
                    "showOnView": true,
                    "showOnForm": true,
                    "readOnly": false,
                    "dataSource": {
                        "name": "product#/motievolcont_crm_perfiresult_crm_perfioper",
                        "rest": true,
                        "lazyLoad": true
                    },
                    "itemsPerPage": 50,
                    "dataSourceFilter": [
                        {
                            "name": "P_NRORG",
                            "operator": "=",
                            "value": "@getLocalVar('CRM_NRORGTRAB')@"
                        },
                        {
                            "name": "P_CDOPERADOR",
                            "operator": "=",
                            "value": "@getLocalVar('CRM_CDOPERADOR')@"
                        }
                    ],
                    "outData": {
                        "NMMOTIEVOCON": "NMMOTIEVOCON",
                        "CDMOTIEVOCON": "CDMOTIEVOCON",
                        "IDENVIAEMAIL": "IDENVIAEMAIL",
                        "NMANEXOPADRAO": "NMANEXOPADRAO",
                        "DSCAMINHOANEXOPADRAO": "DSCAMINHOANEXOPADRAO"
                    },
                    "descriptionField": "NMMOTIEVOCON",
                    "valueField": "CDMOTIEVOCON",
                    "showSelectAs": "grid",
                    "fields": [
                        {
                            
                            "name": "NMMOTIEVOCON",
                            "label": "Motivo da Evolução",
                            "showOnList": true
                        }
                    ],
                    "validations":{  
                        "required":true
                    },
                    "events":[
                        {
                            "name":"FieldOnChange",
                            "code":"evolutionTabController.checkMotievolcont(args.owner.field.widget)"
                        }
                    ]
                },
                {
                    "id": "010",
                    "name": "NMINTERLOCUTOR",
                    "label": "Interlocutor",
                    "template": "field/select.html",
                    "showSelectAs": "grid",
                    "isVisible": true,
                    "showOnForm": true,
                    "showOnList": true,
                    "readOnly": false,
                    "class": "6",
                    "valueField": "NRSEQINTERLOCUTOR",
                    "descriptionField": "NMINTERLOCUTOR",
                    "dataSource": {
                        "name": "product#/crm_interlocutor",
                        "rest": true,
                        "lazyLoad": true
                    },
                    "itemsPerPage": 50,
                    "dataSourceFilter": [
                   
                        {
                            "name": "NRPARCNEGOCIO",
                            "operator": "=",
                            "value": "@General.getFieldValue('NRPARCNEGOCIO', '"+activeWidget.name+"')@"
                        },
                        {
                            "name": "NRORG",
                            "operator": "=",
                            "value": "@getLocalVar('CRM_NRORGTRAB')@"
                        }
                    ],
                    "outData": {
                        "NRSEQINTERLOCUTOR": "NRSEQINTERLOCUTOR",
                        "EMAILINTERLOC": "EMAILINTERLOC",
                        "NRTELEFONE1": "NRTELEFONE1",
                        "NMINTERLOCUTOR": "NMINTERLOCUTOR"
                    },
                    "fields": [
                        {
                            
                            "name": "NMINTERLOCUTOR",
                            "label": "Nome Interlocutor",
                            "isVisible": true,
                            "showOnList": true
                        }
                    ],
                    "events": [
                        {
                            
                            "name": "FieldAfterSelectOpen",
                            "code": "args.owner.field.reload()"
                        }
                    ],
                    "filterProperties": {
                        "isVisible": false,
                        "showOnForm": false
                    }
                },
                {
                    "id": "12932085129618812781121755128",
                    "name": "ESTADOINTERLOCUTOR",
                    "label": "Estado (Interlocutor)",
                    "template": "field/text-edit.html",
                    "showOnForm": false,
                    "showOnView": false,
                    "showOnList": true,
                    "isVisible": true,
                    "events": []
                },
                {
                    "id": "12932085112296181287811127559",
                    "name": "CIDADEINTERLOCUTOR",
                    "label": "Cidade (Interlocutor)",
                    "template": "field/text-edit.html",
                    "showOnForm": false,
                    "showOnView": false,
                    "showOnList": true,
                    "isVisible": true,
                    "events": []
                },
                {
                    "id": "011",
                    "name": "NMSEQRESULEVOL",
                    "label": "Resultado",
                    "template": "field/select.html",
                    "showSelectAs": "grid",
                    "isVisible": true,
                    "showOnForm": true,
                    "showOnList": true,
                    "class": "6",
                    "dataSource": {
                        "name": "product#/crm_resultevol_crm_perfiresult_crm_perfioper",
                        "rest": true,
                        "lazyLoad": true
                    },
                    "itemsPerPage": 50,
                    "dataSourceFilter": [
                        {  
                            "name":"P_NRORG",
                            "operator":"=",
                            "value":"@getLocalVar('CRM_NRORGTRAB')@"
                        },
                        {  
                            "name":"P_CDOPERADOR",
                            "operator":"=",
                            "value":"@getLocalVar('CRM_CDOPERADOR')@"
                        },
                        {  
                            "name":"IDRESULTEVOLUCAO",
                            "operator":"=",
                            "value":"SIM"
                        }
                    ],
                    "descriptionField": "DESCRESULEVOL",
                    "valueField": "NRSEQRESULEVOL",
                    "fields": [
                        {
                            
                            "name": "DESCRESULEVOL",
                            "label": "Resultado da Evolução",
                            "showOnList": true
                        }
                    ],
                    "outData": {
                        "IDGERPROXATIV": "NEWTASK",
                        "DESCRESULEVOL": "NMSEQRESULEVOL",
                        "NRSEQRESULEVOL":"NRSEQRESULEVOL"
                    },
                    "validations":{  
                        "required":true
                    },
                    "events": [
                        {
                            
                            "name": "FieldOnChange",
                            "code": "EvolucaoController.checkNewTask(args.owner.field.widget)"
                        }
                    ]
                },
                {
                    "id": "012",
                    "name": "TXEVOLCONT",
                    "label": "Descrição",
                    "template": "field/textarea.html",
                    "isVisible": true,
                    "showOnForm": true,
                    "class": "12",
                    "validations":{  
                        "required":true
                    },
                    "textRows": 5
                },
                {
                    "id": "013",
                    "name": "DTPLANFILACONTA",
                    "label": "Data da Próxima Tarefa",
                    "template": "field/datetime.html",
                    "showOnForm": true,
                    "showOnList": false,
                    "isVisible": true,
                    "readOnly": true,
                    "class": "4",
                    "fieldGroup": "FG_AGENDAR_TAREFA",
                    "events": []
                },
                {
                    "id": "014",
                    "name": "NMOPERADORREAL",
                    "label": "Operador",
                    "template": "field/select.html",
                    "showSelectAs": "grid",
                    "isVisible": true,
                    "showOnForm": true,
                    "showOnView": true,
                    "showOnList": false,
                    "readOnly": true,
                    "fieldGroup": "FG_AGENDAR_TAREFA",
                    "class": "4",
                    "dataSource": {
                        "name": "product#/operador",
                        "rest": true,
                        "lazyLoad": true
                    },
                    "defaultValue": "@getLocalVar('CRM_NMOPERADOR')@",
                    "itemsPerPage": 50,
                    "dataSourceFilter": [
                        {
                            "name": "NRORG",
                            "operator": "=",
                            "value": "@getLocalVar('CRM_NRORGTRAB')@"
                        },
                        {
                            "name": "IDATIVO",
                            "operator": "=",
                            "value": "S"
                        }
                    ],
                    "descriptionField": "NMOPERADORREAL",
                    "valueField": "CDOPERREAL",
                    "fields": [
                        {
                            
                            "name": "NMOPERADOR",
                            "label": "Operador",
                            "showOnList": true
                        }
                    ],
                    "outData": {
                        "NMOPERADOR": "NMOPERADORREAL",
                        "CDOPERADOR": "CDOPERREAL",
                        "DSEMAILOPER": "DSEMAILOPER"
                    },
                    "validations": {},
                    "events": []
                },
                {
                    "id": "",
                    "name": "DSCLASSIFICATAREFA",
                    "label": "Classificação da Tarefa",
                    "template": "field/select.html",
                    "showSelectAs": "grid",
                    "fields": [
                        {
                            "id": "1616168282555678644284",
                            "name": "DSCLASSIFICATAREFA",
                            "label": "Classificação da Tarefa",
                            "showOnList": true,
                            "isVisible": true,
                            "template": "field/text-edit.html"
                        }
                    ],
                    "isVisible": true,
                    "readOnly": true,
                    "showOnList": false,
                    "showOnView": true,
                    "showOnForm": true,
                    "fieldGroup": "FG_AGENDAR_TAREFA",
                    "class": "4",
                    "valueField": "NRSEQCLASSIFICATAREFA",
                    "descriptionField": "DSCLASSIFICATAREFA",
                    "dataSource": {
                        "name": "product#/crm_classificatarefa",
                        "rest": true,
                        "lazyLoad": true
                    },
                    "itemsPerPage": 50,
                    "dataSourceFilter": [],
                    "outData": {
                        "NRSEQCLASSIFICATAREFA": "NRSEQCLASSIFICATAREFA",
                        "DSCLASSIFICATAREFA": "DSCLASSIFICATAREFA"
                    },
                    "events": [],
                    "searchableFields": [
                        "DSCLASSIFICATAREFA"
                    ],
                    "displayedFields": [
                        "DSCLASSIFICATAREFA"
                    ]
                },
                {
                    "id": "015",
                    "name": "CDOPERREAL",
                    "label": "Código Operador",
                    "template": "field/datetime.html",
                    "showOnForm": false,
                    "showOnList": false,
                    "isVisible": false,
                    "readOnly": false,
                    "class": "6",
                    "defaultValue":"@templateManager.LOGGEDOPERATOR.CDOPERADOR@",
                    "events": []
                },
                {
                    "id": "016",
                    "name": "DSFILACONTATO",
                    "label": "Assunto da Tarefa",
                    "template": "field/text-edit.html",
                    "showOnForm": true,
                    "fieldGroup": "FG_AGENDAR_TAREFA",
                    "readOnly": true,
                    "showOnList": true,
                    "isVisible": true,
                    "defaultValue": "Retornar contato",
                    "class": "12",
                    "events": []
                }
            ],
            "actions": [
                {
                    "id": "017",
                    "name": "BACK_VIEW",
                    "label": "Voltar",
                    "isVisible": true,
                    "preventHide":true,
                    "showAsAction": "back_view",
                    "events": [
                        {
                            
                            "name": "ActionEvent",
                            "code": "General.widgetGoBackToList(args.owner.widget);"
                        }
                    ]
                },
                {
                    "id": "018",
                    "name": "BACK_LIST",
                    "label": "Voltar",
                    "isVisible": true,
                    "preventHide":true,
                    "showAsAction": "back_list",
                    "events": [
                        {
                            
                            "name": "ActionEvent",
                            "code": "General.widgetGoBackToParent(args.owner.widget);"
                        }
                    ]
                },
                {
                    "id": "019",
                    "name": "BACK_EDIT",
                    "label": "Cancelar",
                    "isVisible": true,
                    "showAsAction": "back_edit",
                    "events": [
                        {
                            
                            "name": "ActionEvent",
                            "code": "General.widgetCancelForm(args.owner.widget)"
                        }
                    ]
                },
                {
                    "id": "020",
                    "name": "EDIT",
                    "label": "Editar",
                    "icon": "pencil",
                    "isVisible": true,
                    "showAsAction": "view",
                    "events": [
                        {
                            
                            "name": "ActionEvent",
                            "code": "General.widgetEdit(args.owner.widget)"
                        }
                    ]
                },
                {
                    "id": "021",
                    "name": "ADD",
                    "label": "Adicionar",
                    "icon": "plus",
                    "showAsAction": "always|list",
                    "events": [
                        {
                            
                            "name": "ActionEvent",
                            "code": "General.widgetNewRow(args.owner.widget)"
                        }
                    ]
                },
                {
                    "id": "022",
                    "name": "SAVE",
                    "label": "Salvar",
                    "showAsAction": "never_edit",
                    "events": [
                        {
                            
                            "name": "ActionEvent",
                            "code": "EvolucaoController.checkEvolution(args.owner.widget)"
                        }
                    ]
                },
                {
                    "id": "023",
                    "name": "DELETE",
                    "label": "Excluir",
                    "icon": "trash",
                    "isVisible": false,
                    "preventHide": true,
                    "showAsAction": "view",
                    "events": [
                        {
                            "id": "024",
                            "name": "ActionEvent",
                            "code": "General.deleteCrud(args.owner.widget);"
                        }
                    ]
                }
            ],
            "events": [
                {
                    "id": "025",
                    "name": "WidgetOnEnterOnce",
                    "code": "CRM_Utilities.factoryWidgetActions(args.owner)"
                },
                {
                    "id": "026",
                    "name": "WidgetOnEnter",
                    "code": "CRM_Utilities.setDataSourceFilterOnDynamicTabs(args.owner, templateManager.container.getWidget('" + activeWidget.name + "'))"
                }
            ],
            "widgets": [
                {
                    "id": "1722319758311315390514",
                    "container":activeWidget.container,
                    "name": "WDGT_ANEXOS_EVOLUCAO",
                    "label": "Anexos",
                    "isVisible": true,
                    "showDescriptionOrder": false,
                    "template": "widget/master_detail/grid.html",
                    "dataSource": {
                        "name": "/crm_anexocontato",
                        "rest": true,
                        "lazyLoad": true
                    },
                    "dataSourceFilter": [
                        {
                            "name": "NRSEQCONTATO",
                            "operator": "=",
                            "value": "@General.getFieldValue('NRSEQCONTATO', 'WDGT_EVOLUCAO')@"
                        },
                        {
                            "name": "NRORIGEM",
                            "operator": "=",
                            "value": "@General.getFieldValue('NRSEQEVOLCONT', 'WDGT_EVOLUCAO')@"
                        }
                    ],
                    "events": [
                        {
                            "id": "17223197583113153905171",
                            "name": "WidgetOnEnter",
                            "code": "args.owner.reload()"
                        }
                    ],
                    "actions": [
                        {
                            "id": "1722319758311315390516",
                            "name": "DOWNLOAD",
                            "label": "Download",
                            "isVisible": true,
                            "showAsAction": "never_view",
                            "events": [
                                {
                                    "id": "030",
                                    "name": "ActionEvent",
                                    "code": "EvolucaoController.downloadFile(args.owner.widget);"
                                }
                            ]
                        },
                        {
                            "id": "1722319758311315390517",
                            "name": "ADD",
                            "label": "Adicionar",
                            "icon": "plus",
                            "showAsAction": "always|list",
                            "events": [
                                {
                                    "id": "032",
                                    "name": "ActionEvent",
                                    "code": "EvolucaoController.openAttachSwipe();"
                                }
                            ]
                        },
                        {
                            "id": "1722319758311315390518",
                            "name": "BACK_LIST",
                            "label": "Voltar",
                            "isVisible": true,
                            "preventHide":true,
                            "showAsAction": "back_list",
                            "events": [
                                {
                                    "id": "035",
                                    "name": "ActionEvent",
                                    "code": "General.widgetGoBackToParent(args.owner.widget);"
                                }
                            ]
                        },
                        {
                            "id": "172231975831131539051911",
                            "name": "BACK_VIEW",
                            "label": "Voltar",
                            "isVisible": true,
                            "preventHide":true,
                            "showAsAction": "back_view",
                            "events": [
                                {
                                    "id": "037",
                                    "name": "ActionEvent",
                                    "code": "General.widgetGoBackToList(args.owner.widget);"
                                }
                            ]
                        },
                        {
                            "id": "1722319758311315390591",
                            "name": "DELETE",
                            "label": "Excluir",
                            "icon": "trash",
                            "showAsAction": "view",
                            "events": [
                                {
                                    "id": "039",
                                    "name": "ActionEvent",
                                    "code": "General.deleteCrud(args.owner.widget);"
                                }
                            ]
                        }
                    ],
                    "fields": [
                        {
                            "id": "1722319758311315390592",
                            "name": "NRORIGEM",
                            "label": "Código",
                            "template": "field/text-edit.html",
                            "class": "6",
                            "showOnList": false,
                            "isVisible": false,
                            "readOnly": false
                        },
                        {
                            "id": "1722319758311315390593",
                            "name": "NMARQUIVO",
                            "label": "Nome do arquivo",
                            "class": "12",
                            "isVisible": true,
                            "showOnList": true,
                            "showOnView": true,
                            "readOnly": false,
                            "template": "field/text-edit.html"
                        },
                        {
                            "id": "1722319758311315390594",   
                            "name": "DSTIPO",
                            "label": "Extensão",
                            "class": "6",
                            "isVisible": true,
                            "showOnList": true,
                            "showOnView": true,
                            "readOnly": false,
                            "template": "field/text-edit.html"
                        },
                        {
                            "id": "1722319758311315390595",
                            "name": "VRTAMANHO",
                            "label": "Tamanho do arquivo(bytes)",
                            "class": "6",
                            "isVisible": true,
                            "showOnList": true,
                            "showOnView": true,
                            "readOnly": false,
                            "template": "field/text-edit.html"
                        }
                    ],
                    "widgets": [
                        {
                            "id": "1722319758311315390515",
                            "container":activeWidget.container,
                            "name": "WDGT_SELECAO_ARQUIVOS",
                            "label": "Anexar",
                            "isVisible": false,
                            "template": "widget/form.html",
                            "dataSource": {},
                            "actions": [
                                {
                                    "id": "1722319758311315390519112",
                                    "name": "uploadFile",
                                    "isVisible": true,
                                    "label": "Anexar",
                                    "showAsAction": "never",
                                    "events": [
                                        {
                                            "id": "046",
                                            "name": "ActionEvent",
                                            "code": "EvolucaoController.uploadEvolutionFiles(args.owner.widget);"
                                        }
                                    ]
                                },
                                {
                                    "id": "1722319758311315390519113",
                                    "name": "BACK",
                                    "label": "Cancelar",
                                    "isVisible": true,
                                    "showAsAction": "back",
                                    "events": [
                                        {
                                            "id": "1722319758311315390519114",
                                            "name": "ActionEvent",
                                            "code": "EvolucaoController.closeAttachSwipe(args.owner.widget);"
                                        }
                                    ]
                                }
                            ],
                            "events": [
                                {
                                    "id": "1722319758311315390597",
                                    "name": "WidgetOnEnter",
                                    "code": "args.owner.newRow();"
                                }
                            ],
                            "fields": [
                                {
                                    "id": "1722319758311315390598",
                                    "name": "DSCAMINHO",
                                    "placeholder": "Anexar arquivo",
                                    "class": "10 col-xs-offset-1",
                                    "isVisible": true,
                                    "readOnly": false,
                                    "descriptionOrder": 1,
                                    "validations": {
                                        "required": true
                                    },
                                    "template": "field/file-upload.html",
                                    "isMultiple": true
                                }
                            ]
                        }
                    ]
                }
            ]
        };
        
        var evolutionTabWidget = metaDataFactory.widgetFactory(evolutionTabWidgetJson);
        
        return evolutionTabWidget;
        
    }
    
    
    
    /**
     * Insere a widget de evoluções na widget recebida como 
     * parâmetro.
     * 
     * @param {object} widget widget que receberá a tab.
     * 
     * @param {string} nrparcnegocio nome referente ao
     * campo de parceiro de negócio.
    */
    this.setEvolutionTabOnActiveWidget = function(widget){
        
        widget.widgets.push(_factoryEvolutionTab(widget));
        
    };
    
    /**
     * Sobreescreve qualquer action da tab.
     * 
     * @param {string} actionName nome da action que será sobrescrita.
     *   BACK_VIEW -> Voltar para o grid da tab.
     *   BACK_LIST -> Voltar para o grid principal.
     *   BACK_EDIT -> Cancelar Edição.
     *   EDIT      -> Editar.
     *   ADD       -> Nova Evolução.
     *   SAVE      -> Salvar.
     *   DELETE    -> Excluir.
     * 
     * @param {string} code nome do controller + nome do metodo a ser executado.
     * Ex.:XYController.xyMethod()
    */
    this.overwriteAction = function(actionName, code){
        var evolutionWidget = templateManager.container.getWidget('WDGT_EVOLUCAO');
        if(!evolutionWidget.getAction(actionName).events[0].defaultCode)
            evolutionWidget.getAction(actionName).events[0].defaultCode = evolutionWidget.getAction(actionName).events[0].code;
        templateManager.container.getWidget('WDGT_EVOLUCAO').getAction(actionName).events[0].code = code;    
    };
    
    /**
     * Volta para o evento defalut de qualquer action.
     * 
     * @param {string} actionName nome da action que será sobrescrita.
     *   BACK_VIEW -> Voltar para o grid da tab.
     *   BACK_LIST -> Voltar para o grid principal.
     *   BACK_EDIT -> Cancelar Edição.
     *   EDIT      -> Editar.
     *   ADD       -> Nova Evolução.
     *   SAVE      -> Salvar.
     *   DELETE    -> Excluir.
     * 
    */
    this.defaultAction = function(actionName){
        var evolutionWidget = templateManager.container.getWidget('WDGT_EVOLUCAO');
        if(evolutionWidget.getAction(actionName).events[0].defaultCode)
            evolutionWidget.getAction(actionName).events[0].code = evolutionWidget.getAction(actionName).events[0].defaultCode;
    };
    
    /**
     * Executa comandos após toda a rotina save da evolução.
     * 
     * @param {array} arrayOfMethods array de strings, cada posição 
     * um comando a ser executado.
     * Ex.:[
     *      "ScreenService.closeSwipe(true)",
     *      "XYController.xyMethod()"
     *    ]
    */
    this.setMethodsAfterSave = function(arrayOfMethods){
        var evolutionWidget = templateManager.container.getWidget('WDGT_EVOLUCAO');
        if(evolutionWidget.afterSave)
            evolutionWidget.afterSave.push(...arrayOfMethods);
        else
            evolutionWidget.afterSave = arrayOfMethods;
    };
    
    
    /**
     * Builda novos fieldGroups na tab e chama o metodo de inserção de fields.
     * 
     * @param {array}  arrayOfFields array de fields(json).
     * @param {string} fieldGroupName nome do fieldGroup a ser inserido.
     * 
    */
    this.buildDynamicFieldGroup = function(arrayOfFields, fieldGroupName, fieldGroupLabel){
        var evolutionWidget = templateManager.container.getWidget('WDGT_EVOLUCAO');
        
        var fieldGroup = {
            "name":fieldGroupName,
            "label":fieldGroupLabel,
            "colapsible":true,
            "opened":true,
            "isVisible":true,
            "dynamic":true
        };
        if(this.checkFieldGroup(fieldGroup, evolutionWidget.fieldGroups) === -1){
            if(evolutionWidget.fieldGroups)
                evolutionWidget.fieldGroups.push(fieldGroup);
            else
                evolutionWidget.fieldGroups = [fieldGroup];
            
            evolutionWidget.fieldGroups = evolutionWidget.fieldGroups.map(function(item) {
    			item.widget = evolutionWidget;
    			return Util.extend(new FieldGroup(), item);
    		});
    		//Chama o metodo de inserção
            _insertFields(arrayOfFields, evolutionWidget);
        }
    };
    
    this.checkFieldGroup = function(fieldGroup, fieldGroups){
        var indexField = -1;
        fieldGroups.forEach(function(item, index){
            if(item.name === fieldGroup.name)
                indexField = index;
        });    
        return indexField;
    }
    
    /**
     * Builda os novos Fields na widget
     * 
     * @param {array}  arrayOfFields array de fields(json).
     * @param {string} fieldGroupName nome do fieldGroup a ser inserido.
     * 
    */
    function _insertFields(arrayOfFields, widget){
        arrayOfFields.forEach(function(field){
            field.dynamic = true;
            metaDataFactory.fieldFactory(field, widget, true);  
        });
    }
    
    /**
     * Esconde determinados fieldGroups
     * 
     * @param {string/true} fieldGroupName nome do field
     * group a ser escondido, se = true, esconde todos.
     * 
    */
    this.hideFieldGroup = function(fieldGroupName){
        var evolutionWidget = templateManager.container.getWidget('WDGT_EVOLUCAO');
        
        if(typeof fieldGroupName === "string"){
            evolutionWidget.fieldGroups.forEach(function(fg){
                if(fg.name === fieldGroupName && fg.dynamic){
                    fg.isVisible = false;
                }
            });    
        }else if(fieldGroupName && typeof fieldGroupName === "boolean"){
            evolutionWidget.fieldGroups.forEach(function(fg){
                if(fg.dynamic)
                    fg.isVisible = false;
            });   
        }
        
        evolutionWidget.fields.forEach(function(field){
            if(field.fieldGroup && (field.fieldGroup === fieldGroupName || fieldGroupName === true)){
                if(field.dynamic)
                    field.isVisible = false;
            }
        });
    };
    
    /**
     * Mostra determinados fieldGroups
     * 
     * @param {string/true} fieldGroupName nome do field
     * group a ser mostrado, se = true, mostra todos.
     * 
    */
    this.showFieldGroup = function(fieldGroupName){
        var evolutionWidget = templateManager.container.getWidget('WDGT_EVOLUCAO');
        
        if(typeof fieldGroupName === "string"){
            evolutionWidget.fieldGroups.forEach(function(fg){
                if(fg.name === fieldGroupName && fg.dynamic)
                    fg.isVisible = true;
            });    
        }else if(fieldGroupName && typeof fieldGroupName === "boolean"){
            evolutionWidget.fieldGroups.forEach(function(fg){
                if(fg.dynamic)
                    fg.isVisible = true;
            });   
        }
        
        evolutionWidget.fields.forEach(function(field){
            if(field.fieldGroup && (field.fieldGroup === fieldGroupName || fieldGroupName === true)){
                if(field.dynamic)
                    field.isVisible = true;
            }
        });
    };
    
    /**
     * Verifica se o motivo selecionado permite enviar email
     * para o interlocutor
     * 
     * @param {object} evolWidget  Widget de Evolução
     * 
    */
    this.checkMotievolcont = function(evolWidget){
        widgetMail.fields.forEach(function(field, index){
            if(field.name === 'DSCAMINHO')
                widgetMail.fields.splice(index,1);
        });
        if(evolWidget.currentRow.IDENVIAEMAIL === 'S'){
            //Salva o Anexo default no popup de email
            var file = {
                name: evolWidget.currentRow.NMANEXOPADRAO || '',
                path: evolWidget.currentRow.DSCAMINHOANEXOPADRAO || ''
            };
            this.insertAttachField(file);    
        }
    };
    
    this.insertAttachField = function(file){
        var field = {
            "name": "DSCAMINHO",
            "placeholder": "Anexar arquivo",
            "class": "12",
            "isVisible": true,
            "readOnly": false,
            "validations": {},
            "template": "field/file-upload.html",
            "isMultiple": true,
            "file":file
        };
        widgetMail.fields.push(field);     
    };
    
    var widgetMail = 
        {
            "name": "mensagens",
            "label": "Notificação de Interlocutor",
            "isVisible": false,
            "showAsTab": false,
            "template": "widget/form.html",
            "events": [
                {
                    "id": "6182828512039293853658",
                    "name": "WidgetOnEnter",
                    "code": "args.owner.reload();"
                }
            ],
            "actions": [
                {
                    "id": "618282851568652067654",
                    "name": "enviar",
                    "isVisible": true,
                    "label": "Enviar",
                    "showAsAction": "never",
                    "events": [
                        {
                            "id": "6182828514145614549655",
                            "name": "ActionEvent",
                            "code": "evolutionTabController.notificarInterlocutor(args.owner.widget, args.owner.widget.backuprow)"
                        }
                    ]
                },
                {
                    "id": "6182828511372890396656",
                    "name": "cancel",
                    "label": "Voltar",
                    "showAsAction": "back",
                    "events": [
                        {
                            "id": "6182828512205401251657",
                            "name": "ActionEvent",
                            "code": "ScreenService.closePopup(args.owner.widget);evolutionTabController.removeMessagesWidget(args.owner.widget.parent);"
                        }
                    ]
                }
            ],
            "fields": [
                {
                    "id": "6182828513466738669652",
                    "name": "DSTITULOMENSAGEM",
                    "label": "Assunto da Mensagem",
                    "isVisible": true,
                    "class": 12,
                    "descriptionOrder": 1,
                    "events": [],
                    "showOnList": true,
                    "showOnForm": true,
                    "showOnView": true,
                    "template": "field/text-edit.html",
                    "validations": {
                        "required": {},
                        "maxLength": {
                            "length": 100
                        }
                    }
                },
                {
                    "id": "6182828511660973795653",
                    "name": "DSMENSAGEM",
                    "label": "Mensagem",
                    "class": 12,
                    "placeholder": null,
                    "isVisible": true,
                    "showOnList": false,
                    "showOnForm": true,
                    "showOnView": true,
                    "template": "zh-rich-text#field/rich-text.html",
                    "height": 150,
                    "toolbar": {
                        "fontname": true
                    },
                    "validations": {
                        "required": {}
                    },
                    "events": [],
                    "filterProperty": {
                        "isVisible": false,
                        "showOnForm": false
                    }
                }
            ]
        };

    this.removeMessagesWidget = function(widget){
        widget.widgets.forEach(function(wid, index){
            if(wid.name === "mensagens")
                widget.widgets.splice(index, 1);
        });      
        widget.activate();
    };
    
    this.openWidgetSendMail = function(widget, widgetForActivate = null){
        var promise = ZHPromise.defer();
        if(widget.currentRow.EMAILINTERLOC){
            
            widgetMail.container = widget.container;
            widgetMail = metaDataFactory.widgetFactory(widgetMail);
            widgetMail.parent = widget;
            widget.widgets.push(widgetMail);
            widgetMail.widgetForActivate = widgetForActivate;
            
            widgetMail.currentRow.DSMENSAGEM = '<table border="0" width="100%" cellpadding="0" cellspacing="0" bgcolor="eeeeee" style="background-color: #eeeeee;"> <tbody> <tr> <td> <table border="0" align="center" width="590" cellpadding="0" cellspacing="0" bgcolor="0274BA" class="container590" style="background-color: #0274ba; text-align: center;"> <tbody> <tr> <td> <table border="0" align="center" width="540" cellpadding="0" cellspacing="0" class="container580"> <tbody> <tr> <td align="center" valign="middle"> <table border="0" align="middle" cellpadding="0" cellspacing="0" style="border-collapse:collapse; mso-table-lspace:0pt; mso-table-rspace:0pt;" class=""> <tbody> <tr> <td align="center" valign="middle"> <p style="color: #ffffff; font-size: 25px; padding:20px; font-family: " Questrial ", Helvetica, sans-serif; line-height: 25px; padding-top:45px;">Notificação de Evolução</p> <p style="color: #ffffff; font-size: 16px; font-family: "Questrial", Helvetica, sans-serif; line-height: 15px; padding-top:15px;"> [DATAEVOLUCAO] </p> <p style="color: #ffffff; font-size: 16px; font-family: "Questrial", Helvetica, sans-serif; line-height: 15px; padding-top:15px;">&nbsp;</p> <p style="color: #ffffff; font-size: 16px; font-family: " Questrial ", Helvetica, sans-serif; line-height: 15px; padding-top:15px;"> <br> </p> </td> </tr> </tbody> </table> </td> </tr> </tbody> </table> </td> </tr> </tbody> </table> </td> </tr> </tbody> </table> <table border="0" width="100%" cellpadding="0" cellspacing="0" bgcolor="eeeeee"> <tbody> <tr> <td align="center"> <table border="0" align="center" width="590" cellpadding="0" cellspacing="0" bgcolor="ffffff" class="container590 bg_color"> <tbody> <tr> <td> <table border="0" align="center" width="540" cellpadding="0" cellspacing="0" class="container580"> <tbody> <tr> <td align="left" style="color: #39434b; font-size: 20px; font-family: " Montserrat ", Helvetica, sans-serif; font-weight: 400; padding-bottom:15px; padding-top:20px; line-height: 35px;" class="title_color"> <div style="padding:20px; line-height: 22px"> Prezado(a) [INTERLOCUTOR]</div> </td> </tr> <tr> <td align="left" class="title_color" style="color: #848999; font-size: 14px; font-family: " Questrial ", sans-serif; mso-line-height-rule: exactly; line-height: 24px; padding-bottom:15px;"> <div style="line-height: 24px;"> <br> </div> </td> </tr> <tr> <td height="10" style="font-size: 10px; line-height: 10px;">&nbsp;</td> </tr> </tbody> </table> </td> </tr> </tbody> </table> </td> </tr> </tbody> </table> ';
            //Seta o anexo default no field de upload
            widgetMail.currentRow.DATAEVOLUCAO = widget.currentRow.DTHREVOLCONT;
            widgetMail.backuprow = angular.copy(widget.currentRow);
            ScreenService.openPopup(widgetMail).then(function(){
                promise.resolve();
                widgetMail.activate();
            });
        }else{
            ScreenService.showMessage('Interlocutor não possui email cadastrado!').then(function(){
               promise.resolve(); 
            });
        }
        return promise.promise;
    };
    
    this.notificarInterlocutor = function(widget, row){
        var evolWidget = templateManager.container.getWidget('evolucao');
        if(!evolWidget){
            evolWidget = templateManager.container.getWidget('WDGT_EVOLUCAO');
            evolWidget.currentRow = row;    
        }
        
        var messagesWidget = templateManager.container.getWidget('mensagens');
        messagesWidget.fields.forEach(function(field, index){
            if(field.name === 'DSCAMINHO')
                messagesWidget.fields.splice(index,1);
        }); 
        
        var files = messagesWidget.currentRow.DSCAMINHO;
        var rows = [];
        
        if(!Util.isEmptyOrBlank(files)) {
            files.forEach(function(file, fileIndex){
                rows.push(this.setValuesForFileUpload({DSCAMINHO:widget.currentRow.DSCAMINHO}, fileIndex, evolWidget.currentRow));
                //Se for o anexo default
                if(!Util.isEmptyOrBlank(file.path)){
                    rows[0].DEFAULTATTACH = true;
                }
            }.bind(this));
        }else {
            rows.push(this.setValuesForFileUpload({DSCAMINHO:widget.currentRow.DSCAMINHO}, 0, evolWidget.currentRow));
            rows[0].DEFAULTATTACH = true;
        }
        
        General.callRestEngine("product#/saveAttachEvol", "DataSet", rows).then(function() {
            
                ScreenService.closePopup(true);
                widget.currentRow.NMINTERLOCUTOR  = evolWidget.currentRow.NMINTERLOCUTOR;
                widget.currentRow.DSEMAILINTERLOC = evolWidget.currentRow.EMAILINTERLOC;
                widget.currentRow.NRORG           = templateManager.LOGGEDOPERATOR.NRORG;
                widget.currentRow.NMOPERADORRESP  = evolWidget.currentRow.NMOPERADOR;
                widget.currentRow.NRSEQEVOLCONT   = evolWidget.currentRow.NRSEQEVOLCONT;
                General.callRestEngine("product#/notificaInterlocutorEvolucao", "Row", widget.currentRow);
                this.removeMessagesWidget(evolWidget);
                evolWidget.activate();
                ScreenService.successNotification("Interlocutor notificado com sucesso!");
                if(!Util.isEmptyOrBlank(widget.widgetForActivate)) {
                    var widForActivate = templateManager.container.getWidget(widget.widgetForActivate);
                    widForActivate.activate();
                    widForActivate.list();
                }
        }.bind(this));
        if(templateManager.promise)
            templateManager.promise.resolve();
    };
    
    /**
     * Função para retornar uma row configurada
     * com as informações do anexo referente
     * ao ID, recebido como parâmetro, no array
     * de anexos na currentRow.
     * 
     * @param {object} widget widget onde foi selecionado
     * os anexos.Array
     * 
     * @param {int} fileIndex index do anexo no array de 
     * anexos presente na currentRow.
     * 
     * @return {object} currentRow row configurada com as informações
     * do anexo referente ao ID recebido.
    */
    this.setValuesForFileUpload = function(row, fileIndex){
        
        var currentRow = angular.copy(row);
        var evolutionWidget = templateManager.container.getWidget('evolucao');
        if(!evolutionWidget){
            evolutionWidget = templateManager.container.getWidget('WDGT_EVOLUCAO');
        }
        var loggedOperatorInfos = templateManager.LOGGEDOPERATOR;
        
        currentRow.NRSEQCONTATO = evolutionWidget.currentRow.NRSEQCONTATO;
        currentRow.NMCOMPLETO = currentRow.DSCAMINHO ? currentRow.DSCAMINHO[fileIndex].name : "";
        currentRow.NMARQUIVO = currentRow.DSCAMINHO ? this.getFileNameWithoutExtension(currentRow.DSCAMINHO[fileIndex].name) : "";
        currentRow.DSTIPO = currentRow.DSCAMINHO ? this.getFileExtension(currentRow.DSCAMINHO[fileIndex].name) : "";
        currentRow.VRTAMANHO = currentRow.DSCAMINHO ? currentRow.DSCAMINHO[fileIndex].size : "";
        currentRow.IDATIVO = "S";
        currentRow.NRORG = loggedOperatorInfos.NRORG;
        currentRow.CDOPERADOR = loggedOperatorInfos.CDOPERADOR;
        currentRow.IDORIGEM = "EVOLUCAO";
        currentRow.NRORIGEM = evolutionWidget.currentRow.NRSEQEVOLCONT;
        
        return currentRow;
        
    };
    
    /**
     * Função para retornar a extenção de um arquivo
     * extraida do seu nome.
     * 
     * @param {string} fileName nome completo do arquivo.
    */
    this.getFileExtension = function(fileName){
        
        return fileName.replace(/^(.*)\.(.*)$/, "$2");
        
    };
    
    /**
     * Função para retornar o nome do arquivo sem
     * sua extenção.
     * 
     * @param {string} fileName nome completo do arquivo.
    */
    this.getFileNameWithoutExtension = function(fileName){
        
        return fileName.replace(/^(.*)\.(.*)$/, "$1");
            
    };
	
}
Configuration(function(ContextRegister){
    ContextRegister.register('evolutionTabController', evolutionTabController);
});